#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

int main (int argc, char *argv[])
{
  int n; sscanf (argv[1], "%d", &n);

  srandom (0);
  char **edges = (char**)malloc (n * sizeof (char*));
  for (int i = 0; i < n; i++) {
    edges[i] = (char*)malloc (n * sizeof (char));
  }
  for (int i = 0; i < n; i++) {
    for (int j = i; j < n; j++) {
      edges[i][j] = (char)(random () % 2);
      edges[j][i] = edges[i][j];
    }
  }

  double t = omp_get_wtime ();
  int max = 0;
  unsigned long int subset;
  for (unsigned long int s = 0; s < (1lu << n); s++) {
    int size = 0;
    int clique = 1;
    for (int e1 = 0; e1 < n; e1++) {
      if (((1lu << e1) & s) == 0) continue;
      size++;
      for (int e2 = 0; e2 < n; e2++) {
        if (e1 == e2) continue;
        if (((1lu << e2) & s) == 0) continue;
        clique = clique && (edges[e1][e2] == 1);
        if (clique == 0) break;
      }
      if (clique == 0) break;
    }
    if ((clique == 1) && (size > max)) {
      subset = s; max = size;
    }
  }
  printf ("TIME: %lf\n", omp_get_wtime() - t);

  printf ("subset:%lu size:%d\n", subset, max);
  return 0;
}