#include <stdio.h>
#include <stdlib.h>
#include <omp.h>

int main (int argc, char *argv[]) {
  int n; sscanf (argv[1], "%d", &n);
  double **a = (double**)malloc (n * sizeof (double*));
  double **b = (double**)malloc (n * sizeof (double*));
  double **c = (double**)malloc (n * sizeof (double*));
  for (int i = 0; i < n; i++) {
    a[i] = (double*)malloc (n * sizeof (double));
    b[i] = (double*)malloc (n * sizeof (double));
    c[i] = (double*)malloc (n * sizeof (double));
  }

  for (int i = 0; i < n; i++)
    for (int j = 0; j < n; j++) {
      a[i][j] = 1.0 * i * j; b[i][j] = 2.0 * i * j;
    }

  double t = omp_get_wtime ();
  {
    for (int i = 0; i < n; i++)
      for (int j = 0; j < n; j++) {
        c[i][j] = 0.0;
        for (int k = 0; k < n; k++)
          c[i][j] = c[i][j] + a[i][k] * b[j][k];
      }
  }
  printf ("TIME: %lf\n", omp_get_wtime() - t);

#if 0
  for (int i = 0; i < n; i++) {
    for (int j = 0; j < n; j++)
      printf ("%lf ", c[i][j]);
    printf ("\n");
  }
#endif

  for (int i = 0; i < n; i++) {
    free (a[i]);
    free (b[i]);
    free (c[i]);
  }
  free (a); free (b); free (c);
  return 0;
}
